{
  Anti-Idle script v1.1 by fri
  Kicks spectators that stay for too long on your server. No more slot occupiers!
  
  changelog v1.0 -> v1.1:
  - you can't reset your counter by rejoining anymore. this was widely used to stay on spec team as long as one wanted
  - cleaned up the code a bit
}

const
  SpecMaxTime = 5;  // any spectator will be kicked after X minutes
  SpecBanTime = 5;  // if not 0 then spectator will be banned for X minutes

var
  SpecKick: boolean;
  SpecTime: array[1..32] of integer;


procedure ActivateServer();
var i: byte;
begin
  SpecKick := true;   // set to false if you don't want to activate it automatically when server starts
  for i := 1 to 32 do SpecTime[i] := 0;
end;

procedure AppOnIdle(Ticks: integer);
var i: byte;
begin
  if SpecKick then for i := 1 to 32 do begin 
    if (SpecTime[i] > 0) then begin
      dec(SpecTime[i], 1);
      if (SpecTime[i] mod 60 = 0) and (SpecTime[i] >= 60) then begin
        if GetPlayerStat(i, 'Team') <> 5 then begin // emergency measure
          SpecTime[i] := 0;
          exit;
        end;
        WriteConsole(i, 'You cannot idle as a spectator forever!', $FFFFAAAA);
        WriteConsole(i, 'Time left: ' + inttostr(SpecTime[i] / 60) + iif(SpecTime[i] = 60, ' minute', ' minutes'), $FFFFAAAA);
      end else
      if SpecTime[i] = 15 then begin
         WriteConsole(i, '--- FINAL WARNING ---', $FFFF4444);
         WriteConsole(i, 'Time left: 15 seconds', $FFFF4444);
         end else
      if SpecTime[i] = 0 then begin
        if SpecBanTime > 0 then begin
          WriteConsole(0, GetPlayerStat(i, 'Name') + ' has been kicked for occupying', $FFFF4444);
          WriteConsole(0, 'a slot (banned for ' + inttostr(SpecBanTime) + iif(SpecBanTime = 1, ' minute', ' minutes') + ').', $FFFF4444);
          BanPlayerReason(i, SpecBanTime, ' Spectator idle kick');
        end else begin
          WriteConsole(0, GetPlayerStat(i, 'Name') + ' has been kicked for occupying a slot.', $FFFF4444);
          KickPlayer(i);
        end;
      end;
    end else
    if SpecTime[i] < 0 then begin
      dec(SpecTime[i], 1);
      if SpecTime[i] = -SpecMaxTime * 60 then SpecTime[i] := 0;
    end;
  end;
end;

function OnCommand(ID: Byte; Text: string): boolean;
var i: byte;
begin
  Result := false;
  if (Text = '/skick 1') and (not SpecKick) then begin
    SpecKick := true;
    WriteConsole(0, 'Auto spectator kick enabled.', $FF88FF88);
    for i := 1 to 32 do begin
      if GetPlayerStat(i, 'Team') = 5 then begin
        SpecTime[i] := SpecMaxTime * 60;
        WriteConsole(ID, 'Remember, you cannot idle as a spectator forever!', $FFFFCCCC);
        WriteConsole(ID, 'If you won`t leave or join any team,', $FFFFCCCC);
        WriteConsole(ID, 'you will be kicked in ' + inttostr(SpecMaxTime) + iif(SpecMaxTime = 1, ' minute.', ' minutes.'), $FFFFCCCC);
      end else SpecTime[i] := 0;
    end;
  end else
  if (Text = '/skick 0') and (SpecKick) then begin
    SpecKick := false;
    WriteConsole(0, 'Auto spectator kick disabled.', $FFFF8888);
  end;
end;

procedure OnJoinTeam(ID, Team: byte);
begin
  if (Team = 5) and (SpecKick) then begin
    if SpecTime[ID] < 0 then SpecTime[ID] := -SpecTime[ID]
    else if SpecTime[ID] = 0 then SpecTime[ID] := SpecMaxTime * 60;
    WriteConsole(ID, 'Remember, you cannot idle as a spectator forever!', $FFFFCCCC);
    if (SpecTime[ID] = SpecMaxTime * 60) then begin
      WriteConsole(ID, 'If you won`t leave or join any team,', $FFFFCCCC);
      WriteConsole(ID, 'you will be kicked in ' + inttostr(SpecMaxTime) + iif(SpecMaxTime = 1, ' minute.', ' minutes.'), $FFFFCCCC);
    end else begin
      WriteConsole(ID, 'You have ' + inttostr(SpecTime[ID] div 60) + ' min ' + inttostr(SpecTime[ID] mod 60) + ' s left.', $FFFFCCCC);
    end;
  end else
  if (Team <> 5) and (SpecKick) then begin
    if SpecTime[ID] <> 0 then SpecTime[ID] := -SpecTime[ID];
  end;
end;

procedure OnLeaveGame(ID, Team: byte; Kicked: boolean);
begin
  if SpecTime[ID] <> 0 then SpecTime[ID] := -SpecTime[ID];
end;